/*
Lee Felarca
http://www.zeropointnine.com/blog
11-2011

Source code licensed under a Creative Commons Attribution 3.0 License.
http://creativecommons.org/licenses/by/3.0/
Some Rights Reserved.
*/

package
{
	import com.adobe.serialization.json.JSONDecoder;
	
	import flash.events.Event;
	
	import leelib.ExtendedEvent;
	import leelib.util.Out;
	import leelib.util.Service;
	
	
	public class FlickrUtil extends Service
	{
		private static const FLICKR_REST:String = "http://api.flickr.com/services/rest/";
		
		private var _apiKey:String;

		public function FlickrUtil($apiKey:String)
		{
			_apiKey = $apiKey;
		}
		
		public function search($tags:String, $num:int):void
		{
			// Useful test page:
			// http://www.flickr.com/services/api/explore/?method=flickr.photos.search

			var o:Object = {
				method:			"flickr.photos.search",
				api_key:		_apiKey,
				format:			"json",
				tags:			'"' + $tags + '"',
				privacy_filter:	1, 						/* 1 = public */
				content_type:	1, 						/* 1= photos only */
				media:			"photos", 				/* all | photos | videos */
				sort:			"relevance",			/* date-posted-desc | date-taken-desc | interestingness-desc | relevance */
				per_page:		$num
			}
			
			this.request(FLICKR_REST, o, "GET", Service.RETURNTYPE_JSON_OBJECT);
		}
		
		public function getImageSizes($id:String):void
		{
			var o:Object = {
				api_key:		_apiKey,
				format:			"json",
				method:			"flickr.photos.getSizes",
				photo_id:		$id
			}
			
			this.request(FLICKR_REST, o, "GET", Service.RETURNTYPE_JSON_OBJECT);
		}
		
		protected override function castAndDispatch($responseData:String):void
		{
			// response is wrapped with "jsonFlickrApi(" ... ")" for whatever reason, 
			// so needs to be removed:
			
			Out.d('\rFLICKR RESPONSE: \r' + $responseData + '\r');
			
			var prefix:String = "jsonFlickrApi(";
			var postfix:String = ")";
			
			if ($responseData.indexOf(prefix) == 0) 
				$responseData = $responseData.substr(prefix.length);
			if ($responseData.lastIndexOf(postfix) == $responseData.length - postfix.length) 
				$responseData = $responseData.substr(0, $responseData.length - postfix.length);
			
			super.castAndDispatch($responseData);
		}
		
		//
		
		public static function getIdsFromPhotosSearchObject($o:Object):Array
		{
			var photos:Array = $o.photos.photo;
			
			var a:Array = []
			for (var i:int = 0; i < photos.length; i++) {
				a.push(photos[i].id);
			}
			return a;
		}
	}
}
