package
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.geom.Rectangle;
	
	import leelib.graphics.GrUtil;
	
	import mx.containers.Canvas;
	import mx.utils.GraphicsUtil;
	
	public class ThumbArea extends Canvas
	{
		private var _x:Number;
		private var _thumbLength:Number;
		
		
		public function ThumbArea()
		{
			super();
		}
		
		protected override function initializationComplete():void
		{
			// might not be the best place for this:
			
			this.rawChildren.addChild(GrUtil.makeRect(this.width,this.height,0x0,0.05));
			
			_thumbLength = this.height;
			
			_x = 7;
		}
		
		public function removeThumbs():void
		{
			while (this.rawChildren.numChildren > 1) 
			{
				var s:Sprite = this.rawChildren.getChildAt(1) as Sprite;
				s.graphics.clear();
				this.rawChildren.removeChild(s);
				
				var b:Bitmap = s.getChildAt(0) as Bitmap;
				if (b) {
					s.removeChild(b);
					b.bitmapData.dispose();
					b = null;
				}
				
				s = null;
			}
			_x = 7;
		}
		
		public function get numThumbs():int
		{
			return this.rawChildren.numChildren - 1;
		}
		
		public function addThumb($bmd:BitmapData):void
		{
			var s:Sprite = GrUtil.makeRect(_thumbLength,_thumbLength, 0x0, 0.33);
			s.x = _x;
			
			var bmd2:BitmapData;
			if ($bmd.width > _thumbLength || $bmd.height > _thumbLength)
				bmd2 = GrUtil.fillBitmapDataInto($bmd, _thumbLength,_thumbLength, true);
			else
				bmd2 = $bmd;

			var b:Bitmap = new Bitmap(bmd2);
			
			if (b.width <= _thumbLength && b.height <= _thumbLength) {
				// this might be should be unnecessary - test
				b.x = (_thumbLength - b.width) / 2;
				b.y = (_thumbLength - b.height) / 2;
			}
			else {
				b.x = b.y = 0;
			}
			
			s.addChild(b);
			
			this.rawChildren.addChild(s);
			
			_x += _thumbLength + 8; 

			this.width = _x;
		}
	}
}
