/*
Lee Felarca
http://www.zeropointnine.com/blog
11-2011

Source code licensed under a Creative Commons Attribution 3.0 License.
http://creativecommons.org/licenses/by/3.0/
Some Rights Reserved.
*/

import cmodule.aircall.CLibInit;

import com.greensock.TweenLite;
import com.greensock.easing.Linear;

import flash.display.Bitmap;
import flash.display.BitmapData;
import flash.display.Loader;
import flash.display.Stage;
import flash.events.Event;
import flash.events.IOErrorEvent;
import flash.events.MouseEvent;
import flash.events.OutputProgressEvent;
import flash.events.ProgressEvent;
import flash.filesystem.File;
import flash.filesystem.FileMode;
import flash.filesystem.FileStream;
import flash.filters.GlowFilter;
import flash.net.URLRequest;
import flash.utils.ByteArray;
import flash.utils.getTimer;
import flash.utils.setTimeout;

import leelib.ExtendedEvent;
import leelib.appropriated.PngEncoderAsync;
import leelib.graphics.GrUtil;
import leelib.util.Out;

import mx.controls.Alert;

// ---------------------------------------------------------------------
// API key... http://www.flickr.com/services/apps/create/apply
private static const API_KEY:String = "---MY-API-KEY---"; 
// ---------------------------------------------------------------------

[Embed(source="../embeds/warningIcon.png")]
private static const WarningIcon:Class;

private var _stage:Stage;
private var _service:FlickrUtil;
private var _loader:Loader;

private var _jpegAlchemy:Object;
private var _pngAsync:PngEncoderAsync;
private var _imageBytes:ByteArray;
private var _encodeStartTime:int;
private var _writeStartTime:int;

private var _imageIds:Array;
private var _cursor:int;
private var _numSaved:int;

private var _imageWidth:Number;
private var _imageHeight:Number;

private var _x:Number = 0;

private var _isMouseDown:Boolean;
private var _isStopped:Boolean;

private var _f:File;
private var _fs:FileStream;
private var _fileBrowseDir:File;


private function onCreationComplete():void
{
	_service = new FlickrUtil(API_KEY);
	_loader = new Loader();
	
	var jpeginit:CLibInit = new CLibInit();
	_jpegAlchemy = jpeginit.init();
	_pngAsync = new PngEncoderAsync();
	
	_fs = new FileStream();
	_fileBrowseDir = new File();
		
	var s:String = File.desktopDirectory.nativePath;
	s = addSlashTo(s); 
	s += "fpo"; 
	s = addSlashTo(s); 
	inpDir.text = s;
	
	btnStop.enabled = false;
	btnOpen.enabled = false;

	this.filters = [ new GlowFilter(0x444444, 0.4, 9,9, 2,3) ];
}

private function onAddedToStage():void
{
	_stage = this.stage;
	_stage.addEventListener(MouseEvent.MOUSE_DOWN, onMouseDown);
	_stage.addEventListener(MouseEvent.MOUSE_UP, onMouseUp);
}

private function onBrowseClick():void
{
	_fileBrowseDir.addEventListener(Event.SELECT, onDirSelected);
	_fileBrowseDir.browseForDirectory("Select a directory");
}

private function onDirSelected(e:*):void 
{
	_fileBrowseDir.removeEventListener(Event.SELECT, onDirSelected);
	
	inpDir.text = addSlashTo(_fileBrowseDir.nativePath);
}


private function onGenerateClick():void
{
	var s:String = validateErrorMessage(); 
	if (s) {
		Alert.show(s, "Hello...", Alert.OK, null, null, WarningIcon);
		return;
	}

	showInfo(" ", "Calling Flickr");

	clearListeners();
	btnGenerate.enabled = false;
	btnStop.enabled = true;

	_isStopped = false;
	_x = 0;
	
	thumbArea.removeThumbs();
	
	_imageWidth = parseInt(inpWidth.text);
	_imageHeight = parseInt(inpHeight.text);
	
	getFlickrImages();
}

private function onStopClick():void
{
	_isStopped = true;
	
	clearListeners();
	btnGenerate.enabled = true;
	btnStop.enabled = false;
	
	showInfo("Stopped", " ");
}

private function onOpenClick():void
{
	var f:File;
	try {
		f = new File(inpDir.text);
	}
	catch (e:Error) {}
	
	if (f && f.isDirectory) {
		f.openWithDefaultApplication();
	} else {
		Alert.show("Not a valid directory", "Hello...", Alert.OK, null, null, WarningIcon);
	}
}

private function validateErrorMessage():String
{
	var n:Number = parseFloat(inpWidth.text);
	if (isNaN(n) || n < 1 || n > 2048) return "Width must be beween 1 and 2048";
	
	n = parseFloat(inpHeight.text);
	if (isNaN(n) || n < 1 || n > 2048) return "Height must be beween 1 and 2048";

	n = parseFloat(inpNum.text);
	if (isNaN(n) || n < 1 || n > 500) return "Number of images must be\rbetween 1 and 500";
	
	//
	
	var f:File;
	try {
		f = new File(inpDir.text);
	}
	catch (e:*) {
	}
	
	if (! f) {
		return "Invalid directory";
	}
	else if (! f.isDirectory) {
		if (! f.parent.isDirectory) return "Invalid directory";
	}
	
	// Directory is considered valid at this point...
	inpDir.text = addSlashTo(inpDir.text);
	
	return null;
}

private function getFlickrImages():void
{
	var tags:String = inpTags.text;
	var perPage:int = parseInt(inpNum.text);
	
	var o:Object = {
		api_key:		API_KEY,
		format:			"json",
		method:			"flickr.photos.search",
		tags:			tags,
		privacy_filter:	1, /* 1 = public */
		content_type:	1, /* 1= photos only */
		media:			"photos", /* all | photos | videos */
		is_commons:		true,
		per_page:		perPage
	}
	
		showInfo(null, "Calling Flickr");
		
	_service.addEventListener(IOErrorEvent.IO_ERROR, onFlickrErr);
	_service.addEventListener(Event.COMPLETE, onFlickrResponse);
	_service.search(inpTags.text, parseInt(inpNum.text));
}

private function onFlickrErr($e:IOErrorEvent):void
{
	clearListeners();
	btnGenerate.enabled = true;
	btnStop.enabled = false;
	Alert.show("There was an error with the Flickr service.", "Hello...", Alert.OK, null, null, WarningIcon);
}

private function onFlickrResponse($e:ExtendedEvent):void
{
	_service.removeEventListener(IOErrorEvent.IO_ERROR, onFlickrErr);
	_service.removeEventListener(Event.COMPLETE, onFlickrResponse);

	var o:Object = $e.object;
	_imageIds = FlickrUtil.getIdsFromPhotosSearchObject(o);
	
	if (_imageIds.length == 0) {
		showInfo("No results.", " ");
		btnGenerate.enabled = true;
		btnStop.enabled = false;
		return;
	}
	
	showInfo(o.photos.total.toString() + " results", " ");
	
	_cursor = -1;
	_numSaved = 0;
	generateNextImage();
}

//

private function generateNextImage():void
{
	_cursor++;
	
	if (_isStopped) 
	{
		clearListeners();
		btnGenerate.enabled = true;
		btnStop.enabled = false;
		return;
	}
	
	if (_cursor > _imageIds.length - 1) 
	{
		btnGenerate.enabled = true;
		btnStop.enabled = false;
		clearListeners();
		showInfo("Done.", " ");
		return;
	}
	
	//
	
	showInfo(null, "Calling Flickr");
	
	_service.addEventListener(IOErrorEvent.IO_ERROR, onImageSizesErr);
	_service.addEventListener(Event.COMPLETE, onImageSizesResponse);
	_service.getImageSizes(_imageIds[_cursor]);
}

private function onImageSizesErr($e:IOErrorEvent):void
{
	clearListeners();
	btnGenerate.enabled = true;
	btnStop.enabled = false;
	Alert.show("There was an error with the Flickr service.", "Hello...", Alert.OK, null, null, WarningIcon);
}

private function onImageSizesResponse($e:ExtendedEvent):void
{
	_service.removeEventListener(IOErrorEvent.IO_ERROR, onImageSizesErr);
	_service.removeEventListener(Event.COMPLETE, onImageSizesResponse);
	
	var o:Object = $e.object;
	
	var bestMatch:int = -1;
	var a:Array = o.sizes.size;
	for (var i:int = 0; i < a.length; i++) 
	{
		var w:Number = parseInt(a[i].width);
		var h:Number = parseInt(a[i].height);
		if (w >= _imageWidth && h >= _imageHeight) {
			bestMatch = i;
			break;
		}
	}
	if (bestMatch == -1) bestMatch = a.length-1;
	
	showInfo(null, "Downloading");
	
	var url:String = a[bestMatch].source;
	loadImage(url);
}

private function loadImage($url:String):void
{
	_loader.unloadAndStop(true);
	
	_loader.contentLoaderInfo.addEventListener(IOErrorEvent.IO_ERROR, onImageLoadErr);
	_loader.contentLoaderInfo.addEventListener(Event.COMPLETE, onImageLoaded);
	_loader.load(new URLRequest($url));
}

private function onImageLoadErr($e:IOErrorEvent):void
{
	clearListeners();
	btnGenerate.enabled = true;
	btnStop.enabled = false;
	Alert.show("A load error occurred.", "Hello...", Alert.OK, null, null, WarningIcon);
	Out.e($e.text);
}

private function onImageLoaded($e:Object):void
{
	_loader.contentLoaderInfo.removeEventListener(IOErrorEvent.IO_ERROR, onImageLoadErr);
	_loader.contentLoaderInfo.removeEventListener(Event.COMPLETE, onImageLoaded);

	// scale and crop 
	var bitmap:Bitmap = _loader.content as Bitmap;
	var bmd:BitmapData = GrUtil.fillBitmapDataInto(bitmap.bitmapData, _imageWidth,_imageHeight);
	
	// add thumbnail
	thumbArea.addThumb(bmd);
	setTimeout(onThumbAdded, 1);

	showInfo(null, "Encoding");
	setTimeout(onImageLoaded_2, 33, bmd); // .. allow time for info to display before encoding locks up Flash
}

private function onImageLoaded_2($b:BitmapData):void
{
	// encode 
	_encodeStartTime = getTimer();
	
	var ba:ByteArray;
	
	if (rbJpg.selected) 
	{
		_imageBytes = new ByteArray();
		ba = $b.getPixels($b.rect);
		ba.position = 0;
		_jpegAlchemy.encodeAsync(onJpgEncoded, ba, _imageBytes, $b.width, $b.height, 80, 50);
	} 
	else 
	{
		ba = $b.getPixels($b.rect);
		ba.position = 0;
		_pngAsync.addEventListener(Event.COMPLETE, onPngEncoded);
		_pngAsync.encodeByteArray(ba, $b.width, $b.height, false);
	}
}

private function onJpgEncoded(e:*):void
{
	onImageLoaded_3();
}

private function onPngEncoded($e:Event):void
{
	_pngAsync.removeEventListener(Event.COMPLETE, onPngEncoded);
	_imageBytes = _pngAsync.png;
	onImageLoaded_3();
}

private function onImageLoaded_3():void
{
	Out.d('Encode time:', getTimer() - _encodeStartTime);
	
	saveFile();
}

private function saveFile():void
{
	var strNum:String = (_cursor+1).toString();
	if (strNum.length == 1) 
		strNum = "00" + strNum;
	else if (strNum.length == 2)
		strNum = "0" + strNum;
	
	var path:String = inpDir.text + inpPrefix.text + strNum + (rbJpg.selected ? ".jpg" : ".png");
	
	_imageBytes.position = 0;
	
	_writeStartTime = getTimer();
	
	try 
	{
		_f = new File(path);
		_fs.addEventListener(IOErrorEvent.IO_ERROR, onWriteErr);
		_fs.addEventListener(Event.COMPLETE, onWriteComplete);
		_fs.openAsync(_f, FileMode.UPDATE); // * must use "UPDATE" to get COMPLETE event!
		_fs.writeBytes(_imageBytes);
	}
	catch(e:Error) {
		clearListeners();
		btnGenerate.enabled = true;
		btnStop.enabled = false;
		Alert.show("An error occurred saving image.", "Hello...", Alert.OK, null, null, WarningIcon);
		Out.e(e.message);
	}	
}

private function onWriteErr($e:IOErrorEvent):void
{
	clearListeners();
	btnGenerate.enabled = true;
	btnStop.enabled = false;
	Alert.show("An error occurred saving image.", "Hello...", Alert.OK, null, null, WarningIcon);
	Out.e($e.text);
}	

private function onWriteComplete($e:Event):void
{
	_fs.removeEventListener(IOErrorEvent.IO_ERROR, onWriteErr);
	_fs.removeEventListener(Event.COMPLETE, onWriteComplete);
	_fs.close();
	
	// Meh: Writing takes no time at all, even on large-ish files. Really doesn't need to be done async.
	// Out.i("Write time:", getTimer() - _writeStartTime);
	
	_numSaved++;
	showInfo("Saved " + _numSaved.toString() + " of " + _imageIds.length.toString() + " - " + _f.nativePath, " ");
	if (! btnOpen.enabled) btnOpen.enabled = true;
	
	generateNextImage()	
}

private function onThumbAdded():void
{
	thumbBox.horizontalScrollPosition = Number.MAX_VALUE;	
}

private function showInfo($s1:String, $s2:String):void
{
	if (txtMe.visible) txtMe.visible = false;
	
	if ($s1) {
		if (txtInfo.alpha == 0) TweenLite.to(txtInfo, 0.25, { alpha:1 , ease:Linear.easeNone });
		txtInfo.htmlText = $s1;
	}
	
	if ($s2) txtInfo2.text = $s2;
}

private function addSlashTo($s:String):String
{
	var char:String = ($s.indexOf("/") > -1) ? "/" : "\\"; 

	if ($s.lastIndexOf(char) < $s.length-1) {
		return $s + char;
	}
	else {
		return $s;
	}
}

private function onThumbOverlayOver():void
{
	if (_isMouseDown) return;
	
	if (thumbArea.numThumbs > 0) TweenLite.to(thumbOverlay, 0.3, { alpha:1 } );
}

private function onThumbOverlayOut():void
{
	TweenLite.to(thumbOverlay, 0.3, { alpha:0 } );
}

private function onClose():void
{
	_stage.nativeWindow.close();
}

private function onTitleBarMouseDown():void
{
	if (linkMinimize.hitTestPoint(_stage.mouseX, _stage.mouseY)) return;
	if (linkClose.hitTestPoint(_stage.mouseX, _stage.mouseY)) return;
	
	_stage.nativeWindow.startMove();
}

private function onMinimize():void
{
	_stage.nativeWindow.minimize();
}

private function onMouseDown(e:*):void
{
	_isMouseDown = true;
}
private function onMouseUp(e:*):void
{
	_isMouseDown = false;
	
	if (thumbOverlay.hitTestPoint(_stage.mouseX,_stage.mouseY)) onThumbOverlayOver();
}

private function clearListeners():void
{
	_fileBrowseDir.removeEventListener(Event.SELECT, onDirSelected);
	
	_service.addEventListener(IOErrorEvent.IO_ERROR, onFlickrErr);
	_service.removeEventListener(Event.COMPLETE, onFlickrResponse);
	
	_service.removeEventListener(IOErrorEvent.IO_ERROR, onImageSizesErr);
	_service.removeEventListener(Event.COMPLETE, onImageSizesResponse);
	
	_loader.contentLoaderInfo.removeEventListener(IOErrorEvent.IO_ERROR, onImageLoadErr);
	_loader.contentLoaderInfo.removeEventListener(Event.COMPLETE, onImageLoaded);
	
	_pngAsync.removeEventListener(Event.COMPLETE, onPngEncoded);

	_fs.removeEventListener(IOErrorEvent.IO_ERROR, onWriteErr);
	_fs.removeEventListener(Event.COMPLETE, onWriteComplete);

	try {
		_fs.close();
	}
	catch (e:*) {
	}
}
