package leelib.util
{
	import com.adobe.serialization.json.JSON;
	import com.adobe.serialization.json.JSONDecoder;
	
	import flash.events.Event;
	import flash.events.EventDispatcher;
	import flash.events.IOErrorEvent;
	import flash.net.URLLoader;
	import flash.net.URLLoaderDataFormat;
	import flash.net.URLRequest;
	import flash.net.URLRequestHeader;
	import flash.net.URLVariables;
	
	import leelib.ExtendedEvent;
	
		
	public class Service extends EventDispatcher
	{
		public static const RETURNTYPE_STRING:String = "service.returnTypeString";
		public static const RETURNTYPE_JSON_OBJECT:String = "service.returnTypeJsonObject";
		public static const RETURNTYPE_XML:String = "service.returnTypeXml";
		
		private var _returnType:String;
		
		
		public function Service()
		{
		}
		
		public function request($url:String, $params:Object=null, $method:String="GET", $returnType:String=RETURNTYPE_JSON_OBJECT):void
		{
			Out.i('Service.request() ' + $url + "?" + printObject($params));

			_returnType = $returnType;
			
			var url:String = $url;
			var urlReq:URLRequest = new URLRequest(url);
			var urlVars:URLVariables = new URLVariables();
			
			for ( var i:* in $params ) { 
				urlVars[i] = $params[i];
			}
			urlReq.data = urlVars;

			urlReq.method = $method;

			var urlLoader:URLLoader = new URLLoader(urlReq);
			urlLoader.dataFormat = URLLoaderDataFormat.TEXT;

			urlLoader.addEventListener(Event.COMPLETE, onLoad); 
			urlLoader.addEventListener(IOErrorEvent.IO_ERROR, onError);
			
			urlLoader.load(urlReq); 
		}
		
		private function onLoad($event:Event):void
		{
			var s:String = $event.target.data;
			castAndDispatch(s);
		}
		
		protected function castAndDispatch($responseData:String):void
		{
			var o:Object;
			
			if (_returnType == RETURNTYPE_STRING) {
				o = $responseData as Object;	
			}
			else if (_returnType == RETURNTYPE_JSON_OBJECT) {
				o = new JSONDecoder($responseData, false).getValue(); // xxx STRICT? ... untested
			}
			else if (_returnType == RETURNTYPE_XML){
				o = new XML($responseData) as Object;
			}
			this.dispatchEvent(new ExtendedEvent(Event.COMPLETE, o ));
		}
		
		private function onError($event:IOErrorEvent):void
		{
			Out.e('Service.onError()', $event.text);
			this.dispatchEvent($event); 
		}
		
		private function printObject($o:Object):String
		{
			var string:String = "";
			for (var s:String in $o) {
				string += s + "=" + $o[s] + "&";
			}
			return string;
		}
	}
}

class SingletonEnforcer {}
